/*
oop_ex67.cpp
using this pointer to concatenate member function calls
*/

#include <iostream>
using namespace std;

class Time
{
	int hour;
	int minute;
	int second;

public:
	Time(int h = 0, int m = 0, int s = 0)
	{
		hour = ((h<24 && h >= 0) ? h : 0);
		minute = ((m<60 && m >= 0) ? m : 0);
		second = ((s<60 && s >= 0) ? s : 0);
	}

	void print12HR();
	void print24HR();
	Time& addTime(int h, int m, int s);
	Time& setTime(int h, int m, int s);
	Time* getObjAddress() { return this; }
};


void Time::print12HR()
{
	cout << "<12HR>";
	if (hour > 12)
		cout << hour - 12 << ":" << minute << ":" << second << " PM" << endl;
	else
		cout << hour << ":" << minute << ":" << second << " AM" << endl;
}

void Time::print24HR()
{
	cout << "<24HR>";
	cout << this->hour << ":" << this->minute << ":" << this->second << endl;	//access data member explicitly using this
}

Time& Time::addTime(int h, int m, int s)
{
	hour += h;
	minute += m;
	second += s;

	if (second >= 60)
	{
		int a = second / 60;
		minute += a;
		second %= 60;
	}

	if (minute >= 60)
	{
		int a = minute / 60;
		hour += a;
		minute %= 60;
	}

	if (hour >= 24)
		hour %= 24;

	return *this;	//using this to enable chained function calls
}

Time& Time::setTime(int h, int m, int s)
{
	hour = ((h<24 && h >= 0) ? h : 0);
	minute = ((m<60 && m >= 0) ? m : 0);
	second = ((s<60 && s >= 0) ? s : 0);
	
	return *this;	//using this to enable chained function calls
}


//=======================


void main()
{
	Time showtime(16, 30);
	cout << showtime.getObjAddress() << endl;
	cout << &showtime << endl;

	showtime.print12HR();
	showtime.print24HR();

	//showtime.print12HR().print24HR();	//can't do chained function calls, Why?

	showtime.addTime(2, 20, 0);
	showtime.print12HR();

	showtime.addTime(1, 50, 0).print24HR();	//chained function calls

	showtime.setTime(20, 0, 0).print24HR();		//chained function calls
	
	system("pause");
}


