//oop_ex68.java: this reference in Java

import java.io.*;

class Time
{
	private int hour;
	private int minute;
	private int second;


	public Time(){	this(0,0,0);	}	//can use 'this' to call another constructor
	public Time(int h){	 this(h,0,0);	}
	public Time(int h, int m){	this(h,m,0);	}
	
	public Time(int hour, int minute, int second)	//parameters will hide object's data member
	{						//must using this to refer to object's data member
		this.hour = ((hour<24 && hour>=0) ? hour : 0);
		this.minute = ((minute<60 && minute>=0) ? minute : 0);
		this.second = ((second<60 && second>=0) ? second : 0);
	}

	public void print12HR()
	{
		System.out.print("<12HR>");
		if(hour > 12)
			System.out.println((hour-12)+":"+minute+":"+second+" PM");
		else
			System.out.println(hour+":"+minute+":"+second+" AM");
	}
	
	public void print24HR()
	{
		System.out.print("<24HR>");
		System.out.println(this.hour+":"+this.minute+":"+this.second);	//access data member explicitly using this
	}
	
	public Time addTime(int h, int m, int s)
	{
		hour += h;
		minute += m;
		second += s;

		if(second >= 60)
		{
			int a = second/60;
			minute += a;
			second %= 60;
		}

		if(minute >= 60)
		{
			int a = minute/60;
			hour += a;
			minute %= 60;
		}

		if(hour >= 24)
			hour %= 24;

		return this;	//using this to enable chained method calls
	}
	
	public Time setTime(int hour, int minute, int second)
	{
		this.hour = ((hour<24 && hour>=0) ? hour : 0);
		this.minute = ((minute<60 && minute>=0) ? minute : 0);
		this.second = ((second<60 && second>=0) ? second : 0);
		return this;	//using this to enable chained method calls
	}

	public Time getObjAddress(){ return this; }
}




class test
{
	public static void main(String[] args)
	{	
		Time showtime = new Time(16,30);	
		System.out.println(showtime.getObjAddress());
		System.out.println(showtime);		//showtime is a reference

		showtime.print12HR();
		showtime.print24HR();

		//showtime.print12HR().print24HR();	//can't do chained method calls. Why?

		showtime.addTime(2,20,0);
		showtime.print12HR();

		showtime.addTime(1,50,0).print24HR();	//chained method calls
		
		showtime.setTime(20,0,0).print24HR();	//chained method calls
	}


}