/*
oop_ex71.cpp
friend functions
*/

#include <iostream>
#include <math.h>
using namespace std;



class point
{
	//friend double distBetween(point& p1, point& p2);
	double x;
	double y;
public:
	point()
	{
		x = 0.0;
		y = 0.0;
	}

	point(double xx, double yy)
	{
		x = xx;
		y = yy;
	}

	double distTo(point p);

	friend double distBetween(point& p1, point& p2);
};


double point::distTo(point p)
{
	double dx = x - p.x;
	double dy = y - p.y;
	double dist = sqrt(dx*dx + dy * dy);
	return dist;
}


double distBetween(point& p1, point& p2)
{
	double dx = p1.x - p2.x;
	double dy = p1.y - p2.y;
	double dist = sqrt(dx*dx + dy * dy);
	return dist;
}



void main()
{
	point p1;
	point p2(3, 0);
	point p3(0, 4);

	// using member function -- distTo
	cout << "For point 1, the distance to point 2 is "
		<< p1.distTo(p2) << endl;

	cout << "For point 2, the distance to point 3 is "
		<< p2.distTo(p3) << endl;

	cout << "For point 3, the distance to point 1 is "
		<< p3.distTo(p1) << endl;


	// using friend function -- distBetween
	cout << "The distance between point 1 and point 2 is "
		<< distBetween(p1, p2) << endl;

	cout << "The distance between point 2 and point 3 is "
		<< distBetween(p2, p3) << endl;

	cout << "The distance between point 1 and point 3 is "
		<< distBetween(p1, p3) << endl;

	system("pause");
}

