/*
oop_ex72.cpp
overloading of friend functions
*/
#include <iostream>
#include <math.h>
using namespace std;



class point
{
	double x;
	double y;
public:
	point()
	{
		x = 0.0;
		y = 0.0;
	}

	point(double xx, double yy)
	{
		x = xx;
		y = yy;
	}

	friend double distBetween(point& p1, point& p2);
	friend double distBetween(point& p, double x, double y);
};


double distBetween(point& p1, point& p2)
{
	double dx = p1.x - p2.x;
	double dy = p1.y - p2.y;
	double dist = sqrt(dx*dx + dy * dy);
	return dist;
}


double distBetween(point& p, double x, double y)
{
	double dx = p.x - x;
	double dy = p.y - y;
	double dist = sqrt(dx*dx + dy * dy);
	return dist;
}



void main()
{
	point p1;
	point p2(3, 0);
	point p3(0, 4);


	// using friend function -- distBetween
	cout << "The distance between point 1 and point 2 is "
		<< distBetween(p1, p2) << endl;

	cout << "The distance between point 2 and point 3 is "
		<< distBetween(p2, p3) << endl;

	cout << "The distance between point 1 and point 3 is "
		<< distBetween(p1, p3) << endl;


	// using new overloaded distBetween function
	cout << "The distance between point 1 and (30,40) is "
		<< distBetween(p1, 30, 40) << endl;

	system("pause");
}
