/*
oop_ex73.cpp
friend function for two classes
*/


#include <iostream>
using namespace std;


class vector;  //!!This is required for the doubleMandV function to know vector class!!


class matrix
{
	int *data;
	int size;
public:
	//constructor
	matrix(int s)
	{
		cout << "matrix(int s)" << endl;
		size = s;
		data = new int[size*size];

		for (int i = 0; i<size; i++)
			for (int j = 0; j<size; j++)
				data[i*size + j] = i * size + j;
	}


	//destructor
	~matrix()
	{
		cout << "~matrix()  size=" << size << endl;
		delete [] data;
	}

	void print()
	{
		for (int i = 0; i<size; i++)
		{
			for (int j = 0; j<size; j++)
			{
				cout << data[i*size + j] << " ";
			}
			cout << endl;
		}

		cout << endl;
	}

	void printDataAddress()  //print the address of allocated data
	{
		cout << data << endl;
	}


	// add a new friend function
	friend void doubleMandV(matrix& m, vector& v);
};



class vector
{
	int* data;
	int size;
public:
	// constructor
	vector(int s)
	{
		cout << "vector(int s)" << endl;
		size = s;
		data = new int[size];

		for (int i = 0; i<size; i++)
			data[i] = size;
	}


	//destructor
	~vector()
	{
		cout << "~vector()  size=" << size << endl;
		delete [] data;
	}

	void print()
	{
		for (int i = 0; i<size; i++)
			cout << data[i] << " ";

		cout << endl;
	}

	void printDataAddress()  //print the address of allocated data
	{
		cout << data << endl;
	}


	// add a new friend function
	friend void doubleMandV(matrix& m, vector& v);
};


//must be placed after the definitions of matrix and vector
void doubleMandV(matrix& m, vector& v)
{
	for (int i = 0; i<v.size; i++)
	{
		v.data[i] *= 2;
		for (int j = 0; j<m.size; j++)
			m.data[i*m.size + j] *= 2;
	}
}



void main()
{
	int size;
	cout << "Please enter the size of matrix and vector." << endl;
	cin >> size;

	matrix m(size);
	vector v(size);

	cout << "m = " << endl;
	m.print();

	cout << "v = " << endl;
	v.print();

	doubleMandV(m, v);

	cout << endl << "m = " << endl;
	m.print();

	cout << "v = " << endl;
	v.print();
	system("pause");
}