/*
oop_ex76.cpp
static data member
*/

#include <iostream>
#include <string>
using namespace std;

class Account
{
	double balance;
	int number;
	string owner;

	static const string bank;
	static string branch;
public:
	static double intRate; // = 3.0;	//NG for static data member!

	void setBranch(string b) { branch = b; }
	//static void setBranch(string b){branch = b;}

	Account(double d, int n, string o);
	double getInterest();
	void print();
};

//initialize static member, need data type and class name
const string Account::bank = "bankone";
string Account::branch = "NTUST";
double Account::intRate = 3.0;


Account::Account(double d, int n, string o)
{
	balance = d;
	number = n;
	owner = o;
}

double Account::getInterest()
{
	return balance * intRate / 100;
}

void Account::print()
{
	cout << "Bank = " << bank << ", ";
	cout << "Branch = " << branch << ", ";
	cout << "Account # = " << number << ", ";
	cout << "Owner = " << owner << endl;
	cout << "Balance = " << balance << ", ";
	cout << "intRate = " << intRate << ", ";
	cout << "Interest = " << getInterest() << endl << endl;
}


void main()
{
	Account::intRate = 3.5;	//exists even there is no any Account object exists

	Account c1(30000.0, 1212111, "John");
	Account c2(90000.0, 1212112, "Paul");
	Account c3(10000000.0, 1212113, "Mike");

	c1.print();
	c2.print();
	c3.print();

	// update the public static member (can through class name or an object)
	Account::intRate = 4.0;	//OK
	//c1.intRate = 4.0;			//OK

	// update the private static member (need through public access function)
	//Account::branch = "NTU";		//NG
	//Account::setBranch("NTU");	//OK for static function only
	c3.setBranch("NTU");				//OK

	c1.print();
	c2.print();
	c3.print();

	system("pause");
}


