/*
oop_ex77.cpp
static function member
*/

#include <iostream>
#include <string>
using namespace std;

class Account
{
	double balance;
	int number;
	string owner;

	static const string bank;
	static string branch;
	static double intRate; // = 3.0;	//NG for static data member!
public:
	Account(double d, int n, string o);
	double getInterest();
	void print();

	static void setBranch(string b) { branch = b; }

	static void setIntRate(double i) //const		//const is not allowed on static member functions
	{
		intRate = i;
		//this.intRate = i;								// static member functions do not have 'this' pointers
		//balance +=balance*intRate/100;		// can't using non-static member inside static function
	}
};

//initialize static member
const string Account::bank = "bankone";
string Account::branch = "NTUST";
double Account::intRate = 3.0;


Account::Account(double d, int n, string o)
{
	balance = d;
	number = n;
	owner = o;
}

double Account::getInterest()
{
	return balance * intRate / 100;
}

void Account::print()
{
	cout << "Bank = " << bank << ", ";
	cout << "Branch = " << branch << ", ";
	cout << "Account # = " << number << ", ";
	cout << "Owner = " << owner << endl;
	cout << "Balance = " << balance << ", ";
	cout << "intRate = " << intRate << ", ";
	cout << "Interest = " << getInterest() << endl << endl;
}


void main()
{
	Account c1(30000.0, 1212111, "John");
	Account c2(90000.0, 1212112, "Paul");
	Account c3(10000000.0, 1212113, "Mike");

	c1.print();
	c2.print();
	c3.print();

	// not working if intRate is private
	//Account::intRate = 2.0;			//NG
	//Account::branch = "NTU";		//NG


	//call static function, using class name or object name
	Account::setIntRate(2.0);			//OK
	//c1.setIntRate(2.0);					//OK

	//Account::setBranch("NTU");	//OK 
	c3.setBranch("NTU");				//OK


	c1.print();
	c2.print();
	c3.print();

	system("pause");
}


