/*
	oop_ex78.java
	static function member
*/

import java.io.*;

class Account
{
	private double balance;
	private int number;
	private String owner;

	//initialize static member
	//private static final String bank = "bankone";	
	private static final String bank = getBank();	//can call a static function to initialize it
	private static String branch = "NTUST";
	public static double intRate = 3.0;

	public static String getBank(){String s = new String("Bankone"); return s; }
	
	public Account(double d, int n, String o)
	{
		balance = d;
		number = n;
		owner = o;
	}

	public double getInterest()
	{
		return balance*intRate/100;
	}
	
	public void print()
	{
		System.out.print("Bank = "+bank+", ");
		System.out.print("Branch = "+branch+", ");
		System.out.print("Account # = "+number+", ");
		System.out.println("Owner = "+owner);
		System.out.print("Balance = "+balance+", ");
		System.out.print("intRate = "+intRate+", ");
		System.out.println("Interest = "+getInterest());
	}

	public static void setBranch(String b){branch = b;}

	static void setIntRate(double i)
	{
		intRate = i;
		//this.intRate = i;			// static member functions do not have 'this' reference
		//balance +=balance*intRate/100;	// can't using non-static member inside static function
	}
}





class test
{
	public static void main(String[] args)
	{
		Account c1 = new Account(30000.0, 1212111, "John");
		Account c2 = new Account(90000.0, 1212112, "Paul");
		Account c3 = new Account(10000000.0, 1212113, "Mike");

		c1.print();
		c2.print();
		c3.print();

		// not working for private static member
		Account.intRate = 2.0;		//OK
		//Account.branch = "NTU";	//NG


		//call static function, using class name or object name
		Account.setIntRate(2.0);	//OK
		//c1.setIntRate(2.0);		//OK

		//Account.setBranch("NTU");	//OK 
		c3.setBranch("NTU");		//OK


		c1.print();
		c2.print();
		c3.print();
	}

}
