/*
	oop_ex81.java
	finalizers in Java
*/

import java.io.*;

class Account
{
	private double balance;
	private int number;
	private String owner;

	//initialize static member
	private static final String bank = "bankone";	
	private static String branch = "NTUST";
	public static double intRate = 3.0;
	private static int objCount = 0;	//the number of Account objects created
	
	public Account(double d, int n, String o)
	{
		balance = d;
		number = n;
		owner = o;
		
		objCount++;
	}

	// get current number of Account object created
	public static int getNumOfObj(){return objCount;}

	// Finalizer, decrease the objCount
	protected void finalize()
	{
		--objCount;
		System.out.println("call final()");
	}
	
	
	
	public double getInterest()
	{
		return balance*intRate/100;
	}
	
	public void print()
	{
		System.out.print("Bank = "+bank+", ");
		System.out.print("Branch = "+branch+", ");
		System.out.print("Account # = "+number+", ");
		System.out.println("Owner = "+owner);
		System.out.print("Balance = "+balance+", ");
		System.out.print("intRate = "+intRate+", ");
		System.out.println("Interest = "+getInterest());
	}

	public static void setBranch(String b){branch = b;}

	static void setIntRate(double i)
	{
		intRate = i;
		//this.intRate = i;			// static member functions do not have 'this' pointers
		//balance +=balance*intRate/100;	// can't using non-static member inside static function
	}
}





class test
{
	public static void main(String[] args)
	{
		Account c1 = new Account(30000.0, 1212111, "John");
		Account c2 = new Account(90000.0, 1212112, "Paul");
		Account c3 = new Account(10000000.0, 1212113, "Mike");

		System.out.println("The number of Account objects currently exists is " 
						   + Account.getNumOfObj());

		c1.print();
		c2.print();
		c3.print();

		c1=null;
		c2=null;
		c3=null;
		System.gc();
		
		System.out.println("The number of Account objects currently exists is " 
						   + Account.getNumOfObj());
	}
}
